<template>
  <div class="contenedor">
    <div :id="name_id" :style="filtros.styleObject"></div>
  </div>
</template>
<script>
import store from "@/store";
const periodoSupervisionMtto = store.state.periodoSupervisionMtto;
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
export default {
  name: "GraficaMediaCircular",
  props: {
    name_id: String,
  },
  data() {
    return {
      chart: null,
      periodo: {},
      filtros: {
        value: 0,
        target1: 0,
        categoria: "Categoria",
        name_id: "",
        datos: ["", ""],
        styleObject: {
          width: "100%",
          height: "310px",
          margin: "auto",
        },
        rColores: [],
        rCalf: [],
      },
    };
  },
  methods: {
    metodo2() {
      alert("hola");
    },
    initChartG() {
      const self = this;
      am4core.useTheme(am4themes_animated);

      // Create chart instance
      var chart = am4core.create(this.filtros.name_id, am4charts.RadarChart);
      chart.logo.hidden = true;

      // Add data
      chart.data = [
        {
          category: "",
          value: this.filtros.value,
          full: this.filtros.target1,
          full2: this.filtros.target2,
        },
      ];

      // Make chart not full circle
      chart.startAngle = -180;
      chart.endAngle = 0;
      chart.innerRadius = am4core.percent(90);

      // Set number format
      chart.numberFormatter.numberFormat = "#.#";

      // Create axes
      var categoryAxis = chart.yAxes.push(new am4charts.CategoryAxis());
      categoryAxis.dataFields.category = "category";
      categoryAxis.renderer.grid.template.location = 100;
      categoryAxis.renderer.grid.template.strokeOpacity = 0;
      categoryAxis.renderer.labels.template.horizontalCenter = "right";
      categoryAxis.renderer.labels.template.fontWeight = 20;
      categoryAxis.renderer.labels.template.adapter.add("fill", function (fill, target) {
        return target.dataItem.index >= 0
          ? chart.colors.getIndex(target.dataItem.index)
          : fill;
      });
      categoryAxis.renderer.minGridDistance = 300;
      categoryAxis.tooltip.disabled = true;

      let porcentajeAvance = Math.round(
        (this.filtros.value * 100) / this.filtros.target2
      );
      if (isNaN(porcentajeAvance)) porcentajeAvance = 0;

      var label = chart.createChild(am4core.Label);
      label.text = porcentajeAvance + "%";
      label.fontSize = 40;
      label.align = "center";
      label.isMeasured = false;
      label.x = am4core.percent(50);
      label.y = am4core.percent(30);
      label.horizontalCenter = "middle";
      label.fontWeight = "bolder";

      var label1 = chart.createChild(am4core.Label);
      label1.text = this.filtros.datos[0]; //"Puntos de Venta Certificados";
      label1.fontSize = 14;
      label1.align = "center";
      label1.isMeasured = false;
      label1.x = am4core.percent(50);
      label1.y = am4core.percent(45);
      label1.horizontalCenter = "middle";
      label1.fontWeight = "bolder";

      var label2 = chart.createChild(am4core.Label);
      label2.text =
        this.filtros.value +
        " supervisiones realizadas \n" +
        this.filtros.target2 +
        " programadas al día de hoy"; //"¡Quedan "  + " días para alcanzar la cobertura!";
      label2.fontSize = 12;
      label2.align = "center";
      label2.isMeasured = false;
      label2.x = am4core.percent(50);
      label2.y = am4core.percent(60);
      label2.horizontalCenter = "middle";
      label2.fontWeight = "bold";

      var label3 = chart.createChild(am4core.Label);
      label3.text =
        "Total supervisiones programadas al " +
        this.periodo.periodo +
        ": " +
        this.filtros.target1;
      label3.fontSize = 12;
      label3.align = "center";
      label3.isMeasured = false;
      label3.x = am4core.percent(50);
      label3.y = am4core.percent(80);
      label3.horizontalCenter = "middle";
      label3.fontWeight = "bold";
      label3.color = am4core.color("grey");

      var valueAxis = chart.xAxes.push(new am4charts.ValueAxis());
      valueAxis.renderer.grid.template.strokeOpacity = 0;
      valueAxis.min = 0;
      valueAxis.max = this.filtros.target;
      valueAxis.strictMinMax = true;
      valueAxis.tooltip.disabled = true;

      // Create series
      var series1 = chart.series.push(new am4charts.RadarColumnSeries());
      series1.dataFields.valueX = "full";
      series1.dataFields.categoryY = "category";
      series1.clustered = false;
      series1.columns.template.fill = new am4core.InterfaceColorSet().getFor(
        "alternativeBackground"
      );
      series1.columns.template.fillOpacity = 0.08;
      series1.columns.template.cornerRadiusTopLeft = 20;
      series1.columns.template.strokeWidth = 0;
      series1.columns.template.radarColumn.cornerRadius = 50;
      series1.columns.template.width = am4core.percent(150);
      //series1.columns.template.tooltipText = "Programadas al trimestre: {valueX}";

      var series3 = chart.series.push(new am4charts.RadarColumnSeries());
      series3.dataFields.valueX = "full2";
      series3.dataFields.categoryY = "category";
      series3.clustered = false;
      series3.columns.template.strokeWidth = 0;
      series3.columns.template.radarColumn.cornerRadius = 20;
      series3.columns.template.fill = new am4core.InterfaceColorSet().getFor(
        "alternativeBackground"
      );
      series3.columns.template.fillOpacity = 0.2;
      series3.columns.template.width = am4core.percent(80);
      //series3.columns.template.tooltipText = "Programadas al dia de hoy del trimestre: {valueX}";

      var series2 = chart.series.push(new am4charts.RadarColumnSeries());
      series2.dataFields.valueX = "value";
      series2.dataFields.categoryY = "category";
      series2.clustered = false;
      series2.columns.template.strokeWidth = 0;
      series2.columns.template.radarColumn.cornerRadius = 20;
      series2.columns.template.fill = new am4core.InterfaceColorSet().getFor(
        "alternativeBackground"
      );
      series2.columns.template.fillOpacity = 1;
      series2.columns.template.width = am4core.percent(50);
      //series2.columns.template.tooltipText = "Realizadas al dia de hoy del trimestre: {valueX}";

      let color = "#ffcd00";
      for (var i = 0; i < this.filtros.rCalf.length; ++i) {
        let rangoSuperior = this.filtros.rCalf[i].split(",")[1];
        let rangoInferior = this.filtros.rCalf[i].split(",")[0];

        if (rangoSuperior >= porcentajeAvance && porcentajeAvance >= rangoInferior) {
          color = this.filtros.rColores[i];
        }
      }
      /*
            var porcentaje = this.filtros.value *100 / this.filtros.target;
            var color;
            for (var i = 0; i < this.filtros.rCalf.length; ++i) {
                if(porcentaje<=this.filtros.rCalf[i]) {
                    color = this.filtros.rColores[i];
                    break;
                }
            }
*/
      series2.columns.template.adapter.add("fill", function (fill, target) {
        return am4core.color(color);
      });

      series3.columns.template.adapter.add("fill", function (fill, target) {
        return am4core.color("#1D1D1D");
      });

      chart.cursor = new am4charts.RadarCursor();
      chart.cursor.innerRadius = am4core.percent(90);
      chart.cursor.lineY.disabled = true;
      chart.cursor.lineX.disabled = true;

      valueAxis.cursorTooltipEnabled = false;
      chart.arrangeTooltips = true;
      this.chart = chart;
    },
    setValores(filtros) {
      this.filtros = filtros;
      this.initChartG();
    },
  },
  mounted() {
    this.filtros.name_id = this.name_id;
  },
  created() {
    this.periodo = periodoSupervisionMtto;
  },
  beforeDestroy() {
    if (this.chart != null) {
      this.chart.dispose();
    }
  },
};
</script>
